# $Owl: Owl/packages/findutils/findutils.spec,v 1.21 2005/12/08 23:41:54 ldv Exp $

Summary: The GNU versions of find utilities (find and xargs).
Name: findutils
Version: 4.2.27
Release: owl1
Epoch: 1
License: GPL
Group: Applications/File
URL: http://www.gnu.org/software/%name/
Source0: ftp://ftp.gnu.org/gnu/%name/%name-%version.tar.gz
Source1: findutils-ru.po
Patch0: findutils-4.2.27-cvs-20050923-quotearg.diff
Patch1: findutils-4.2.25-up-savedir.diff
Patch2: findutils-4.2.27-alt-warnings.diff
Patch3: findutils-4.2.21-alt-find-check_nofollow.diff
Patch4: findutils-4.2.21-owl-info.diff
PreReq: /sbin/install-info
# due to sed -i
BuildRequires: sed >= 4.1.1
BuildRequires: automake, autoconf, libtool, gettext, texinfo
BuildRoot: /override/%name-%version

%description
The findutils package contains programs which will help you locate
files on your system.  The find utility searches through a hierarchy
of directories looking for files which match a certain set of criteria
(such as a filename pattern).  The xargs utility builds and executes
command lines from standard input arguments (usually lists of file
names generated by the find command).

%prep
%setup -q
install -pm644 %_sourcedir/findutils-ru.po po/ru.po
%patch0 -p0
%patch1 -p0
%patch2 -p1
%patch3 -p1
%patch4 -p1

%{expand:%%define optflags %optflags -Wall}

%build
# do not build the locate subdirectory
sed -i 's/ locate / /' Makefile*
# The regex.h must be kept in sync with --without-included-regex.
install -pm644 %_includedir/regex.h gnulib/lib/
%configure --without-included-regex
make -C po update-po
make

%install
rm -rf %buildroot
%makeinstall

# Remove unpackaged files if any
rm -f %buildroot%_infodir/dir

%post
/sbin/install-info %_infodir/find.info %_infodir/dir

%preun
if [ $1 -eq 0 ]; then
	/sbin/install-info --delete %_infodir/find.info %_infodir/dir
fi

%files
%defattr(-,root,root)
%doc NEWS README
%_bindir/find
%_bindir/xargs
%_mandir/man1/find.1*
%_mandir/man1/xargs.1*
%_infodir/find.info*
%_datadir/locale/*/LC_MESSAGES/findutils.mo

%changelog
* Thu Dec 08 2005 Dmitry V. Levin <ldv-at-owl.openwall.com> 1:4.2.27-owl1
- Updated to 4.2.27.

* Wed Nov 16 2005 Dmitry V. Levin <ldv-at-owl.openwall.com> 1:4.2.25-owl2
- Backported savedir() fix from gnulib CVS.

* Sat Sep 17 2005 Dmitry V. Levin <ldv-at-owl.openwall.com> 1:4.2.25-owl1
- Updated to 4.2.25.

* Tue Jun 21 2005 Dmitry V. Levin <ldv-at-owl.openwall.com> 1:4.2.23-owl1
- Updated to 4.2.23.

* Thu Jun 16 2005 Dmitry V. Levin <ldv-at-owl.openwall.com> 1:4.2.22-owl2
- Fixed few harmless compilation warnings.

* Mon Jun 13 2005 Dmitry V. Levin <ldv-at-owl.openwall.com> 1:4.2.22-owl1
- Updated to 4.2.22.

* Sat Jun 11 2005 Dmitry V. Levin <ldv-at-owl.openwall.com> 1:4.2.21-owl1
- Updated to 4.2.21.
- Reviewed Owl patches, removed obsolete ones.
- Imported two patches and updated Russian translation from ALT's
findutils-4.2.21-alt2 package.
- Corrected info files installation.
- Packaged findutils translations.
- Added URL.

* Mon Aug 19 2002 Michail Litvak <mci-at-owl.openwall.com> 1:4.1.7-owl2
- Deal with info dir entries such that the menu looks pretty.

* Tue May 14 2002 Solar Designer <solar-at-owl.openwall.com>
- Updated to 4.1.7.

* Fri Feb 01 2002 Solar Designer <solar-at-owl.openwall.com>
- Build with -Wall; this produces very few warnings which should be
dealt with at next update.

* Fri Feb 01 2002 Michail Litvak <mci-at-owl.openwall.com>
- Enforce our new spec file conventions.

* Sat Sep 23 2000 Alexandr D. Kanevskiy <kad-at-owl.openwall.com>
- import spec from RH
- import "-delete" patch by Douglas Siebert <douglas-siebert at uiowa.edu>
