# $Owl: Owl/packages/john/john.spec,v 1.75.2.1 2006/03/25 14:50:18 solar Exp $

Summary: John the Ripper password cracker.
Name: john
Version: 1.7.0.2
%define charsets_version 20051216
Release: owl1
License: GPL
Group: Applications/System
URL: http://www.openwall.com/john/
Source0: john-%version.tar.gz
Source1: john-charsets-%charsets_version.tar.bz2
BuildRoot: /override/%name-%version

%description
John the Ripper is a fast password cracker (password security auditing
tool).  Its primary purpose is to detect weak Unix passwords, but a number
of other hash types are supported as well.

%prep
%setup -q -a 1

%define cflags -c %optflags -finline-limit=2000 --param inline-unit-growth=2000 -Wall -DJOHN_SYSTEMWIDE=1
%define with_cpu_fallback 0

%build
cd src
%ifarch athlon i786 i886 i986
make linux-x86-mmx CFLAGS='%cflags'
%else
%ifarch %ix86
%define with_cpu_fallback 1
make linux-x86-any CFLAGS='%cflags'
mv ../run/john ../run/john-non-mmx
make clean
make linux-x86-mmx CFLAGS='%cflags -DCPU_FALLBACK=1'
%endif
%endif
%ifarch alpha alphaev5 alphaev56 alphapca56 alphaev6 alphaev67
make linux-alpha CFLAGS='%cflags'
%endif
%ifarch sparc sparcv9
make linux-sparc CFLAGS='%cflags'
%endif
%ifarch ppc
make linux-ppc32 CFLAGS='%cflags'
%endif

%install
rm -rf %buildroot
mkdir -p %buildroot{%_bindir,%_datadir/john}
install -m 700 run/john %buildroot%_bindir/
cp -a run/un* %buildroot%_bindir/
%if %with_cpu_fallback
mkdir -p %buildroot%_libexecdir/john
install -m 700 run/john-* %buildroot%_libexecdir/john/
%endif
install -m 644 -p run/{john.conf,password.lst} \
	john-charsets-%charsets_version/*.chr \
	%buildroot%_datadir/john/
install -m 644 -p run/mailer doc/

%files
%defattr(-,root,root)
%doc doc/*
%attr(750,root,wheel) %_bindir/john
%_bindir/un*
%if %with_cpu_fallback
%dir %_libexecdir/john
%attr(750,root,wheel) %_libexecdir/john/*
%endif
%dir %_datadir/john
%attr(640,root,wheel) %config(noreplace) %_datadir/john/john.conf
%attr(644,root,root) %_datadir/john/password.lst
%attr(644,root,root) %_datadir/john/*.chr

%changelog
* Mon Mar 20 2006 Solar Designer <solar-at-owl.openwall.com> 1.7.0.2-owl1
- Fixed a long-standing bug in the rule preprocessor which caused some
duplicate characters to not be omitted on platforms where ARCH_WORD is bigger
than int (that's all supported 64-bit platforms).

* Tue Mar 07 2006 Solar Designer <solar-at-owl.openwall.com> 1.7.0.1-owl1
- Fixed a bug introduced with 1.6.40 which caused spurious "charset file
changed" errors in batch mode if interrupted and restored before pass 3.
- Handle 8-bit characters in external mode program sources correctly.
Thanks to Frank Dittrich for reporting these two problems.
- Implemented extra ticks overflow safety - timer-based rather than just
crypts count based.
- Save/update the recovery file after the end of each pass in batch mode
to make sure that the file is up to date in case the next pass refuses to
start for whatever reason.
- Remove the recovery file when all hashes get cracked also in batch mode.
- Detect and report MinLen / MaxLen settings and charset files inconsistent
with the hash type.
- Perform additional sanity checking of charset files, distinguish incorrect
vs. incompatible ones.
- Use sysconf(_SC_CLK_TCK) instead of CLK_TCK when _SC_CLK_TCK is known to
be available or CLK_TCK is not (needed for glibc 2.3.90+).
- Worked around a gcc 4.1.0 strict aliasing bug affecting BF_std.c, BF_body:
http://gcc.gnu.org/bugzilla/show_bug.cgi?id=26587
- Added a separate DO_ALIGN(5) (cache line alignment) into x86.S after a
possible switch to .bss from .data or .text.
- Added "notes to packagers" to params.h.
- Added a sample but fully-functional "keyboard-based" external mode to the
default john.conf.

* Thu Feb 02 2006 Solar Designer <solar-at-owl.openwall.com> 1.7-owl2
- Pass -finline-limit=2000 --param inline-unit-growth=2000 to gcc such that
it inlines the S-boxes on non-x86 just like gcc 2.x used to do.

* Mon Jan 09 2006 Solar Designer <solar-at-owl.openwall.com> 1.7-owl1
- Documentation updates: separated CONTACT from CREDITS, added some FAQ
entries, etc.
- When displaying programs' usage information, use either an equivalent of
basename(argv[0]) (with the main John program) or fixed strings (with the
auxiliary tools).
- In rec_done(), do a log_flush() even if the session completes normally;
this is needed to hopefully update the pot file prior to our removal of the
crash recovery file.
- Applied some Cygwin-specific updates to signals.c and DOS/Win32-specific
updates to the Makefile.

* Fri Dec 16 2005 Solar Designer <solar-at-owl.openwall.com> 1.6.40-owl1
- Detect changed charset files when restoring sessions.
- Updated the supplied password.lst.
- Added a new pre-defined "incremental" mode "Alnum", along with its
corresponding filter.
- Package new charset files (a separate tarball) instead of those from 1.6.

* Sat Nov 12 2005 Solar Designer <solar-at-owl.openwall.com> 1.6.39.4-owl1
- Corrected the way nouns ending in "z" and "h" (other than those ending in
"ch" and "sh") are pluralized with the "p" wordlist rules command.

* Tue Nov 08 2005 Solar Designer <solar-at-owl.openwall.com> 1.6.39.3-owl1
- When eliminating any duplicate and already-cracked hashes, compare the
internal representations first.
- When displaying cracked passwords, let split() unify the encoding of hashes.
(This only works when the only difference is upper vs. lower vs. mixed case
since we're using a hash table and would not do a comparison against hashes
which look very different.)
- Force the encoding of LM hashes that get into john.pot to all-lowercase.
- Corrected the handling of break statements with nested loops in the external
mode compiler.

* Fri Oct 28 2005 Solar Designer <solar-at-owl.openwall.com> 1.6.39.2-owl1
- Re-worked the Makefile: dropped "-elf" suffixes from make target names,
re-ordered the targets for best to most generic (for individual platforms),
marked some targets as "best" or "obsolete", added openbsd-x86-64 (thanks to
Sebastian Rother), added many openbsd-* targets based on the OpenBSD port.
- Minor corrections to EXAMPLES.

* Sun Oct 09 2005 Solar Designer <solar-at-owl.openwall.com> 1.6.39.1-owl1
- With linux-sparc make target, let's not use sparc.S because it uses
registers reserved by the SPARC ABI (%g5-%g7) and this no longer works with
glibc 2.3.x.
- Fixed a bug in best.sh which could result in MD5_IMM being enabled wrongly
when MD5_X2 is determined to improve performance (this only affected builds
with "make generic").
- Added a workaround for "some kaserver.DB0 files created by OpenAFS"; this
issue was brought up on john-users by Heiko Schulz and the patch produced by
Lionel Cons (thanks!)

* Thu Sep 08 2005 Solar Designer <solar-at-owl.openwall.com> 1.6.39-owl1
- Fixed a bug in the loader introduced with 1.6.37.10 where "john --show"
would report split hashes with the last piece not yet cracked as if they
were fully cracked (thanks to Stephen Cartwright for the problem report).

* Mon Sep 05 2005 Solar Designer <solar-at-owl.openwall.com> 1.6.38.2-owl1
- All of the remaining bits of John 1.6 documentation have been updated to
apply to the current version.
- Dropped John 1.6 documentation from the package.
- Added the macosx-x86-mmx-cc make target (thanks to Brian Bechtel).

* Sun May 15 2005 Solar Designer <solar-at-owl.openwall.com> 1.6.38.1-owl1
- Added a sample case toggler for cracking MD4-based NTLM hashes (with the
contributed patch), given already cracked DES-based LM hashes.

* Wed May 04 2005 Solar Designer <solar-at-owl.openwall.com> 1.6.38-owl1
- Further updates of the PPC make targets for Mac OS X 10.4+ and Linux/ppc64.

* Wed Apr 27 2005 Solar Designer <solar-at-owl.openwall.com> 1.6.37.11-owl1
- Fixed a long-standing bug in "unshadow" which showed up on recent OpenBSD.
- Added the openbsd-x86-mmx-elf make target.

* Wed Apr 20 2005 Solar Designer <solar-at-owl.openwall.com> 1.6.37.10-owl1
- Fixed a long-standing bug in the loader where "john --show" would segfault
when an invalid or unsupported hash is present in both john.pot and the
password file.

* Wed Apr 20 2005 Solar Designer <solar-at-owl.openwall.com> 1.6.37.9-owl1
- Corrected handling of BSDI-style DES-based hashes and of 8-bit characters
with traditional DES-based hashes; this was broken with the previous change.

* Tue Apr 17 2005 Solar Designer <solar-at-owl.openwall.com> 1.6.37.8-owl1
- Even more bitslice DES set_key*() optimizations: use a separate loop for
undoing the old password beyond the new password's length (this simplifies
the exit check of both loops), store byte offsets into K[] rather than bit
positions in s1[] (this simplifies effective address calculation), quickly
skip over the first 4 characters if they're unchanged (on archs supporting
unaligned accesses only).

* Tue Apr 05 2005 Solar Designer <solar-at-owl.openwall.com> 1.6.37.7-owl1
- Further bitslice DES set_key*() optimizations.

* Mon Feb 28 2005 Solar Designer <solar-at-owl.openwall.com> 1.6.37.6-owl1
- Generic bitslice DES set_key*() optimizations.
- Further AltiVec optimizations for LM hashes.

* Tue Feb 15 2005 Solar Designer <solar-at-owl.openwall.com> 1.6.37.4-owl1
- New make target for 64-bit PowerPC (G5+) running Mac OS X (32-bit
inter-function interfaces).
- New make targets for PowerPC w/ AltiVec (effective 128-bitness for
bitslice DES).

* Tue Nov 09 2004 Solar Designer <solar-at-owl.openwall.com> 1.6.37.3-owl1
- Properly report effective c/s rates in excess of 2**32 (now up to
2**32 * 10**6), report large c/s rates in thousands or millions.

* Sat Jun 19 2004 Solar Designer <solar-at-owl.openwall.com> 1.6.37.2-owl1
- "N passwords cracked" -> "N password hashes cracked" because there can be
multiple hashes per password with LM or double-length DES-based crypt(3).
- Updated some documentation files from John 1.6 and included them in doc/

* Sun Jun 13 2004 Solar Designer <solar-at-owl.openwall.com> 1.6.37.1-owl1
- Freeze the timestamps that are being logged for the duration of loading
of password files; clock is reset to 0 or to the restore point when the
actual cracking starts to ensure the reported c/s rate is not affected by
load time, but we don't want this clock reset to be seen in event logs.

* Mon Feb 23 2004 Solar Designer <solar-at-owl.openwall.com> 1.6.37-owl1
- Bumped the release to 1.6.37 to make it available separately from Owl.

* Sat Jan 10 2004 Solar Designer <solar-at-owl.openwall.com> 1.6.36.9-owl1
- Corrected a segfault with --stdin introduced with 1.6.34.2.

* Wed Dec 03 2003 Solar Designer <solar-at-owl.openwall.com> 1.6.36.8-owl1
- Avoid triggering a Mac OS X cpp bug(?) where it would detect and refuse to
handle "recursive" cpp macros.

* Sun Nov 30 2003 Solar Designer <solar-at-owl.openwall.com> 1.6.36.7-owl1
- When calculating the c/s rate in benchmarks (bench.c, best.c), use 64-bit
integer operations to avoid a possible integer overflow on 32-bit systems
with large CLK_TCK (e.g. Win32).

* Sun Nov 16 2003 Solar Designer <solar-at-owl.openwall.com> 1.6.36.6-owl1
- When generating a new charset file, first do a self-test of the specified
CHARSET_* parameters to ensure they don't cause a 64-bit integer overflow.

* Sat Oct 25 2003 Solar Designer <solar-at-owl.openwall.com> 1.6.36.5-owl1
- In x86 assembly code, detect and choose optimal existing code version for
Centaur Technology processors (IDT Winchip to VIA C3 and beyond).

* Fri Oct 10 2003 Solar Designer <solar-at-owl.openwall.com> 1.6.36.4-owl1
- Also support Matthew Kwan's older DES S-box expressions with standard
gates only, use them for x86-64 and autodetect between them and the
non-standard gates version with "make generic".

* Sun Oct 05 2003 Solar Designer <solar-at-owl.openwall.com> 1.6.36.3-owl1
- Added two make targets for Linux on x86-64, thanks to John Edward Scott.

* Wed Oct 01 2003 Solar Designer <solar-at-owl.openwall.com> 1.6.36.2-owl1
- Replaced mem_free() with a macro to keep gcc 3.3.1's strict aliasing
happy (thanks to Anatoly Pugachev for reporting the gcc warnings).

* Mon Sep 22 2003 Solar Designer <solar-at-owl.openwall.com> 1.6.36.1-owl1
- Support OpenBSD/x86 w/ ELF binaries (Makefile patch by demon).

* Thu Sep 18 2003 Solar Designer <solar-at-owl.openwall.com> 1.6.36-owl1
- Corrected the generic and SPARC make targets broken with 1.6.34.2.

* Mon Sep 15 2003 Solar Designer <solar-at-owl.openwall.com> 1.6.35-owl1
- Log two more events.
- With the AIX make target, use -qunroll=2 instead of plain -qunroll.

* Sun Sep 07 2003 Solar Designer <solar-at-owl.openwall.com> 1.6.34.2-owl1
- Verbose logging; John now logs how it proceeds through stages of each
of its cracking modes, regardless of whether there're guesses or not.

* Mon Aug 25 2003 Solar Designer <solar-at-owl.openwall.com> 1.6.34.1-owl1
- Added an event logging framework; only session start/stop, cracking
modes, and cracked login names are logged currently, but the plan is to
log many more events in the future.

* Sun Jun 29 2003 Solar Designer <solar-at-owl.openwall.com> 1.6.34-owl1
- solaris-sparc64-cc, contributed by Thomas Nau.
- Check for and report invalid MinLen / MaxLen settings.

* Mon Jun 02 2003 Solar Designer <solar-at-owl.openwall.com> 1.6.33-owl2
- Added URL.

* Fri Jan 24 2003 Solar Designer <solar-at-owl.openwall.com> 1.6.33-owl1
- Added a 64-bit Solaris SPARC make target (recent gcc only for now).

* Wed Jan 15 2003 Solar Designer <solar-at-owl.openwall.com>
- Split the 64-bit MIPS target into two such that it is possible to have
64-bit builds which do or don't require at least an R10K CPU.

* Tue Nov 05 2002 Solar Designer <solar-at-owl.openwall.com>
- Workaround a Solaris stdio bug triggered by code in "unique".

* Fri Nov 01 2002 Solar Designer <solar-at-owl.openwall.com>
- Fixed a bug in "unique" which caused it to fail on big-endian boxes
on files bigger than a single buffer, thanks to Corey Becker.

* Sat Oct 19 2002 Solar Designer <solar-at-owl.openwall.com>
- Simplified DES_bs_get_binary_raw().

* Thu Oct 03 2002 Solar Designer <solar-at-owl.openwall.com>
- Never point cfg_name to path_expand()'s result buffer, make a copy.

* Thu Sep 05 2002 Solar Designer <solar-at-owl.openwall.com>
- Never put dupes in crk_guesses, that could overflow it and would be
inefficient anyway.

* Fri Apr 26 2002 Solar Designer <solar-at-owl.openwall.com>
- Check for with_cpu_fallback correctly (unbreak builds on non-x86).

* Thu Apr 11 2002 Solar Designer <solar-at-owl.openwall.com>
- On x86, always build the MMX binary, with a run-time fallback to the
non-MMX one if necessary.

* Wed Apr 10 2002 Solar Designer <solar-at-owl.openwall.com>
- Packaged 1.6.31-dev for Owl, with minor modifications.
