# $Owl: Owl/packages/owl-control/owl-control.spec,v 1.19 2005/11/16 13:21:54 solar Exp $

Summary: A set of scripts to control installed system facilities.
Name: owl-control
Version: 0.7
Release: owl1
License: public domain
Group: System Environment/Base
Source0: functions
Source1: control
Source2: control-dump
Source3: control-restore
Source4: control.8
Source5: control-dump.8
Source6: control-restore.8
Requires: /bin/sh, /dev/null, sh-utils, fileutils, findutils
Requires: sed, grep, mktemp
BuildArchitectures: noarch
BuildRoot: /override/%name-%version

%description
The scripts included in this package provide a common interface to
control system facilities provided by a number of other packages.
This is intended for use primarily by packages which are providing
a facility that can potentially be dangerous to system security,
to let you enable, disable, or configure the facility independently
from package installation.

%install
rm -rf %buildroot
mkdir -p %buildroot{/etc/control.d/facilities,%_sbindir,%_mandir/man8}
cp %_sourcedir/functions %buildroot/etc/control.d/
cp %_sourcedir/control{,-dump,-restore} %buildroot%_sbindir/
cp %_sourcedir/control{,-dump,-restore}.8 %buildroot%_mandir/man8/

%files
%defattr(0700,root,root)
%dir /etc/control.d
%dir /etc/control.d/facilities
%attr(0600,root,root) /etc/control.d/functions
%_sbindir/control*
%attr(0644,root,root) %_mandir/man8/control*

%changelog
* Thu May 26 2005 Dmitry V. Levin <ldv-at-owl.openwall.com> 0.7-owl1
- Deal with the warning generated by recent versions of GNU find.
- Changed define() and validate() functions to handle arbitrary
values properly.
- Optimized functions for speed.

* Fri Apr 18 2003 Solar Designer <solar-at-owl.openwall.com> 0.6-owl1
- Avoid *roff commands within .SH NAME to not confuse makewhatis and
apropos(1).

* Wed Jan 08 2003 Solar Designer <solar-at-owl.openwall.com>
- Wrote control(8) and control-dump(8) manual pages.

* Sun Nov 03 2002 Solar Designer <solar-at-owl.openwall.com>
- Imported some of the ALT Linux updates, including (modified versions of)
the control-dump and control-restore scripts.
- In control_subst(), don't rewrite files when the new setting is the same.
- Install the scripts into %_sbindir directly, no more symlinks.

* Sun Jul 07 2002 Solar Designer <solar-at-owl.openwall.com>
- Use grep -q in the provided shell functions.

* Wed Feb 06 2002 Michail Litvak <mci-at-owl.openwall.com>
- Enforce our new spec file conventions.

* Wed Nov 22 2000 Solar Designer <solar-at-owl.openwall.com>
- Support extended regexp's in control_subst().

* Fri Aug 11 2000 Solar Designer <solar-at-owl.openwall.com>
- Various important changes to the provided shell functions.
- Wrote the package description.
- Moved the symlink: /sbin/control is now /usr/sbin/control.

* Thu Aug 10 2000 Solar Designer <solar-at-owl.openwall.com>
- Initial version.
