# $Owl: Owl/packages/setarch/setarch.spec,v 1.4 2005/12/21 19:47:19 solar Exp $

Summary: Personality setter.
Name: setarch
Version: 1.8
Release: owl1
License: GPL
Group: System Environment/Kernel
Source: %name-%version.tar.gz
Patch0: setarch-1.8-owl-sparc32-alias.diff
%ifarch sparc sparcv9 sparc64
Provides: sparc32
Obsoletes: sparc32
%endif
ExclusiveArch: %ix86 x86_64 sparc sparcv9 sparc64 ppc ppc64 ia64 s390 s390x
BuildRoot: /override/%name-%version

%description
This utility tells the kernel to report a different architecture than
the current one, then runs a program in that environment.  It can also
set various personality flags.

%prep
%setup -q
%patch0 -p1

%build
%__cc -o setarch setarch.c %optflags

%install
rm -rf %buildroot
mkdir -p %buildroot%_bindir %buildroot%_mandir/man8
install -p -m644 setarch.8 %buildroot%_mandir/man8/
install -m755 setarch %buildroot%_bindir/

LINKS="linux32"
%ifarch %ix86 x86_64
LINKS="$LINKS i386 x86_64"
%endif
%ifarch sparc sparcv9 sparc64
LINKS="$LINKS sparc sparc64 sparc32"
%endif
%ifarch ppc ppc64
LINKS="$LINKS ppc ppc64 ppc32"
%endif
%ifarch ia64
LINKS="$LINKS i386 ia64"
%endif
%ifarch s390 s390x
LINKS="$LINKS s390 s390x"
%endif
for i in $LINKS; do
	ln -s setarch %buildroot%_bindir/$i
	echo '.so man8/setarch.8' > %buildroot%_mandir/man8/$i.8
done

%files
%defattr(-,root,root)
%_bindir/*
%_mandir/man8/*

%changelog
* Thu Oct 20 2005 Dmitry V. Levin <ldv-at-owl.openwall.com> 1.8-owl1
- Minor specfile cleanup.

* Tue Oct 18 2005 Alexandr D. Kanevskiy <kad-at-owl.openwall.com>
- Initial build for Openwall GNU/*/Linux, based on RH package.
- fix sparc32 alias.
