# $Owl: Owl/packages/vsftpd/vsftpd.spec,v 1.21 2006/02/03 22:16:41 ldv Exp $

Summary: File Transfer Protocol (FTP) server.
Name: vsftpd
Version: 2.0.3
Release: owl2
License: GPL
Group: System Environment/Daemons
URL: http://vsftpd.beasts.org
# The primary site for releases is ftp://ferret.lmh.ox.ac.uk/pub/linux/
Source0: ftp://ftp.beasts.org/users/cevans/vsftpd-%version.tar.gz
Source1: vsftpd.eps.gz
Source2: vsftpd.pam
Source3: vsftpd.xinetd
Source4: vsftpd.logrotate
Patch0: vsftpd-2.0.3-owl-pam_userpass.diff
Patch1: vsftpd-2.0.3-owl-warnings.diff
Patch2: vsftpd-2.0.3-suse-owl-tz.diff
Patch3: vsftpd-2.0.3-owl-alt-defaults.diff
Patch4: vsftpd-2.0.3-alt-owl-man.diff
Requires: logrotate, pam >= 0:0.80-owl2, pam_userpass, tcb, xinetd, /var/empty
Provides: ftpserver
BuildRequires: pam-devel, pam_userpass-devel, libcap-devel
BuildRoot: /override/%name-%version

%description
vsftpd is a File Transfer Protocol (FTP) server.  The "vs" stands for
Very Secure.  Obviously this is not a guarantee, but a reflection that
the entire codebase has been written with security in mind, and the
program has been carefully designed to be resilient to attack.

%prep
%setup -q
%patch0 -p1
%patch1 -p1
%patch2 -p1
%patch3 -p1
%patch4 -p1
install -p -m 644 %_sourcedir/vsftpd.eps.gz .
bzip2 -9 Changelog

%build
make CFLAGS="%optflags -Wall -W -Wshadow" LIBS="-lcap -lpam -lpam_userpass"

%install
rm -rf %buildroot
mkdir -p %buildroot/{usr/sbin,etc/{pam.d,xinetd.d,logrotate.d}}
mkdir -p %buildroot%_mandir/man{5,8}
install -m 700 vsftpd %buildroot/usr/sbin/
install -m 600 vsftpd.conf %buildroot/etc/
install -m 644 vsftpd.conf.5 %buildroot%_mandir/man5/
install -m 644 vsftpd.8 %buildroot%_mandir/man8/
cd %_sourcedir
install -m 600 vsftpd.pam %buildroot/etc/pam.d/vsftpd
install -m 600 vsftpd.xinetd %buildroot/etc/xinetd.d/vsftpd
install -m 600 vsftpd.logrotate %buildroot/etc/logrotate.d/vsftpd
touch %buildroot/etc/ftpusers

%pre
grep -q ^vsftpd: /etc/group || groupadd -g 187 vsftpd
grep -q ^vsftpd: /etc/passwd ||
	useradd -g vsftpd -u 187 -d / -s /bin/false -M vsftpd
set noclobber
test -e /etc/ftpusers || echo root > /etc/ftpusers
chmod 600 /etc/ftpusers
mkdir -m 755 /home/ftp &> /dev/null || :

%files
%defattr(-,root,root)
%doc COPYING FAQ LICENSE README
%doc README.security REWARD SECURITY/
%doc BENCHMARKS SPEED TUNING
%doc BUGS TODO
%doc EXAMPLE/
%doc Changelog.bz2
%doc vsftpd.eps.gz
/usr/sbin/vsftpd
%config(noreplace) /etc/vsftpd.conf
%config(noreplace) /etc/pam.d/vsftpd
%config(noreplace) /etc/xinetd.d/vsftpd
%config(noreplace) /etc/logrotate.d/vsftpd
%ghost %config %attr(0600,root,root) /etc/ftpusers
%_mandir/man5/vsftpd.conf.5*
%_mandir/man8/vsftpd.8*

%changelog
* Fri Feb 03 2006 Dmitry V. Levin <ldv-at-owl.openwall.com> 2.0.3-owl2
- Compressed Changelog file.

* Sun Nov 27 2005 Dmitry V. Levin <ldv-at-owl.openwall.com> 2.0.3-owl1
- Updated to 2.0.3.
- Fixed the problem with timezone in chroot.

* Sat Oct 29 2005 Dmitry V. Levin <ldv-at-owl.openwall.com> 1.2.1-owl0.3
- Changed PAM config file to include system-auth for PAM account and
session management.
- Stripped /lib/security/ prefix from PAM module names.

* Sat Jun 19 2004 Dmitry V. Levin <ldv-at-owl.openwall.com> 1.2.1-owl0.2
- vsftpd.conf(5): note that session_support is disabled by default.
- vsftpd.pam: set proper session management entry.

* Sun Oct 26 2003 Solar Designer <solar-at-owl.openwall.com> 1.2.1-owl0.1
- Updated to 1.2.1pre1.
- Let vsftpd use libcap now that we package it.
- Package the control flow diagram from our presentation slides; the dia
source to vsftpd.eps is available through the download link from
http://www.openwall.com/presentations/Owl/

* Thu Apr 17 2003 Solar Designer <solar-at-owl.openwall.com> 1.0.2-owl0.3
- Pass prefix= and count= to pam_tcb also for authentication such that it
can use this information to reduce timing leaks.

* Thu Apr 03 2003 Dmitry V. Levin <ldv-at-owl.openwall.com> 1.0.2-owl0.2
- Updated pam_userpass support: build with libpam_userpass.

* Tue Apr 02 2002 Solar Designer <solar-at-owl.openwall.com>
- Updated to 1.0.2pre3.
- Set hide_ids to YES.

* Sat Feb 02 2002 Solar Designer <solar-at-owl.openwall.com>
- Enforce our new spec file conventions.

* Sun Dec 16 2001 Solar Designer <solar-at-owl.openwall.com>
- Adjusted the default tunable settings, based some on those from ALT Linux.
- Patched in pam_userpass support.
- Wrote PAM and xinetd configuration files.
- Took vsftpd.logrotate from the ALT Linux package.
- Based this spec file on Seth Vidal's with heavy modifications.
